import logging
import os
import sys
from logging.handlers import RotatingFileHandler
from em_tasks.utils.mongo_product import MongoProduct
from cmutils.config_loaders import IniConfigLoader


logger = logging.getLogger('em_tasks.' + __name__)
formatter = logging.Formatter('%(asctime)s [%(levelname)s]: %(message)s')
logger.setLevel(logging.DEBUG)
stream_handler = logging.StreamHandler(sys.stdout)
stream_handler.setFormatter(formatter)
logger.addHandler(stream_handler)

def get_config():
    config_path = os.path.join('~', '.em_celery', 'config.ini')
    config = IniConfigLoader(config_path)
    return config.load()
