from em_tasks.spapi.spapi_catalog_items_parser import SpapiCatalogItemsParser
from em_tasks.tasks.spapi_update_item_offers_task import SpapiUpdateItemOffersTask
from em_tasks import logger


class SpapiOfferUpdater():
  def __init__(self, spapi, marketplace, asins_loader, offer_service):
    self.spapi = spapi
    self.marketplace = marketplace
    self.asins_loader = asins_loader
    self.offer_service = offer_service

  def run(self):
    asins_buf = []
    batch_size = 20
    for asin in self.asins_loader.load():
      asins_buf.append(asin)
      if len(asins_buf) < batch_size:
        continue

      self.update_offers(asins_buf)

      asins_buf = []

    if asins_buf:
      self.update_offers(asins_buf)

  def update_offers(self, asins):
    try:
      offer_task = SpapiUpdateItemOffersTask(self.spapi, self.offer_service, self.marketplace, asins)
      offer_task.run()
    except Exception as e:
      logger.exception(e)
      logger.error('[SpapiUpdateItemOffersTaskException] No Retry')
