def validate_prods(prods):

    ensure_product_keys = ['product_id', 'source', 'source_product_id', 'variants']
    ensure_variant_keys = ['variant_id', 'sku', 'price', 'currency', 'quantity']
    if not isinstance(prods, dict):
        raise Exception("prods is not a dict")


    for key, value in prods.items():
        if not isinstance(key, str) or not key.isdigit():
            raise Exception(f"invalid key {key}")
        if not isinstance(value, dict):
            raise Exception(f"invalid value {value}")


        for product_key in ensure_product_keys:
            if product_key not in value:
                raise Exception(f"missing key {product_key}")

        for variant in value['variants']:
            for variant_key in ensure_variant_keys:
                if variant_key not in variant:
                    raise Exception(f"missing key {variant_key}")






